<< problem 59 - XOR decryption | Cyclical figurate numbers - problem 61 >> |
Problem 60: Prime pair sets
(see projecteuler.net/problem=60)
The primes 3, 7, 109, and 673, are quite remarkable. By taking any two primes and concatenating them in any order the result will always be prime.
For example, taking 7 and 109, both 7109 and 1097 are prime. The sum of these four primes, 792, represents the lowest sum for a set of four primes with this property.
Find the lowest sum for a set of five primes for which any two primes concatenate to produce another prime.
My Algorithm
Let's skip forward tomain
: a simple prime sieve finds all primes below 20000 (or whatever the user input is).Then each prime a is matched against each larger prime b > a: if a merged with b is prime and b merged with
a
is prime, then a and b are a prime pair.When looking at my code, a is actually named
smallPrime
and b is named largePrime
.After calling the function
match
(see below) all primes pairs of smallPrime
are stored in candidates
.Now each element of
candidates
definitely forms a prime pair with smallPrime
.The original problem asks for a set of five primes, but the Hackerrank problem extends this to 3, 4 and 5 primes.
The functions
checkTriple
, checkQuadruple
and checkQuintuple
follow the same idea:match
each candidate
against each other using nested loops. If 3, 4 or 5 primes match simultanueously, then insert the sum into sums
(which is a simple container keeping track of all results).
At the end of the problem,
sums
is sorted and displayed.Helper functions
merge
concatenate two numbers a
and b
: the smallest shift = 10^x is found such that shift > b.
Then the result ist a * shift + b. You can do the same pretty easy with strings but that's much slower.
match
checks whether the concatenated numbers ab
and ba
are prime (using the Miller-Rabin test I copied from problem 50).
Modifications by HackerRank
As explained before, the prime sets may contain either (at least) 3, 4 or 5 primes.
Note: do not eliminate duplicate sums from the output. This was actually pretty unclear to me and took me quite some time to figure out.
Note
That's the longest code I had to write for a Project Euler problem so far !
(at least I could copy about 50% from previous problems ...)
Interactive test
You can submit your own input to my program and it will be instantly processed at my server:
This is equivalent toecho "700 4" | ./60
Output:
(this interactive test is still under development, computations will be aborted after one second)
My code
… was written in C++11 and can be compiled with G++, Clang++, Visual C++. You can download it, too. Or just jump to my GitHub repository.
#include <vector>
#include <iostream>
#include <algorithm>
// will be the result
std::vector<unsigned int> sums;
// return (a*b) % modulo
unsigned long long mulmod(unsigned long long a, unsigned long long b, unsigned long long modulo)
{
#ifdef __GNUC__
// use GCC's optimized 128 bit code
return ((unsigned __int128)a * b) % modulo;
#endif
// (a * b) % modulo = (a % modulo) * (b % modulo) % modulo
a %= modulo;
b %= modulo;
// fast path
if (a <= 0xFFFFFFF && b <= 0xFFFFFFF)
return (a * b) % modulo;
// we might encounter overflows (slow path)
// the number of loops depends on b, therefore try to minimize b
if (b > a)
std::swap(a, b);
// bitwise multiplication
unsigned long long result = 0;
while (a > 0 && b > 0)
{
// b is odd ? a*b = a + a*(b-1)
if (b & 1)
{
result += a;
if (result >= modulo)
result -= modulo;
// skip b-- because the bit-shift at the end will remove the lowest bit anyway
}
// b is even ? a*b = (2*a)*(b/2)
a <<= 1;
if (a >= modulo)
a -= modulo;
// next bit
b >>= 1;
}
return result;
}
// return (base^exponent) % modulo
unsigned long long powmod(unsigned long long base, unsigned long long exponent, unsigned long long modulo)
{
unsigned long long result = 1;
while (exponent > 0)
{
// fast exponentation:
// odd exponent ? a^b = a*a^(b-1)
if (exponent & 1)
result = mulmod(result, base, modulo);
// even exponent ? a^b = (a*a)^(b/2)
base = mulmod(base, base, modulo);
exponent >>= 1;
}
return result;
}
// Miller-Rabin-test
bool isPrime(unsigned long long p)
{
// some code from https://ronzii.wordpress.com/2012/03/04/miller-rabin-primality-test/
// with optimizations from http://ceur-ws.org/Vol-1326/020-Forisek.pdf
// good bases can be found at http://miller-rabin.appspot.com/
// trivial cases
const unsigned int bitmaskPrimes2to31 = (1 << 2) | (1 << 3) | (1 << 5) | (1 << 7) |
(1 << 11) | (1 << 13) | (1 << 17) | (1 << 19) |
(1 << 23) | (1 << 29); // = 0x208A28Ac
if (p < 31)
return (bitmaskPrimes2to31 & (1 << p)) != 0;
if (p % 2 == 0 || p % 3 == 0 || p % 5 == 0 || p % 7 == 0 || // divisible by a small prime
p % 11 == 0 || p % 13 == 0 || p % 17 == 0)
return false;
if (p < 17*19) // we filtered all composite numbers < 17*19, all others below 17*19 must be prime
return true;
// test p against those numbers ("witnesses")
// good bases can be found at http://miller-rabin.appspot.com/
const unsigned int STOP = 0;
const unsigned int TestAgainst1[] = { 377687, STOP };
const unsigned int TestAgainst2[] = { 31, 73, STOP };
const unsigned int TestAgainst3[] = { 2, 7, 61, STOP };
// first three sequences are good up to 2^32
const unsigned int TestAgainst4[] = { 2, 13, 23, 1662803, STOP };
const unsigned int TestAgainst7[] = { 2, 325, 9375, 28178, 450775, 9780504, 1795265022, STOP };
// good up to 2^64
const unsigned int* testAgainst = TestAgainst7;
// use less tests if feasible
if (p < 5329)
testAgainst = TestAgainst1;
else if (p < 9080191)
testAgainst = TestAgainst2;
else if (p < 4759123141ULL)
testAgainst = TestAgainst3;
else if (p < 1122004669633ULL)
testAgainst = TestAgainst4;
// find p - 1 = d * 2^j
auto d = p - 1;
d >>= 1;
unsigned int shift = 0;
while ((d & 1) == 0)
{
shift++;
d >>= 1;
}
// test p against all bases
do
{
auto x = powmod(*testAgainst++, d, p);
// is test^d % p == 1 or -1 ?
if (x == 1 || x == p - 1)
continue;
// now either prime or a strong pseudo-prime
// check test^(d*2^r) for 0 <= r < shift
bool maybePrime = false;
for (unsigned int r = 0; r < shift; r++)
{
// x = x^2 % p
// (initial x was test^d)
x = powmod(x, 2, p);
// x % p == 1 => not prime
if (x == 1)
return false;
// x % p == -1 => prime or an even stronger pseudo-prime
if (x == p - 1)
{
// next iteration
maybePrime = true;
break;
}
}
// not prime
if (!maybePrime)
return false;
} while (*testAgainst != STOP);
// prime
return true;
}
// merge two numbers, "append their digits"
unsigned long long merge(unsigned long long a, unsigned long long b)
{
// merge(12, 34) => 1234
unsigned long long shift = 10;
while (shift <= b)
shift *= 10;
return a * shift + b;
}
// true if a and b can be merged in any way and the result is still a prime
bool match(unsigned long long a, unsigned long long b)
{
return isPrime(merge(a, b)) && isPrime(merge(b, a));
}
// find all triplets:
// all numbers in "candidates" already match with first
// now we have to check every numbers in "candidates" against each other
void checkTriple(unsigned int first, const std::vector<unsigned int>& candidates)
{
for (size_t index2 = 0; index2 < candidates.size(); index2++)
for (size_t index3 = index2 + 1; index3 < candidates.size(); index3++)
// match ?
if (match(candidates[index2], candidates[index3]))
{
// append sum to result set
auto sum = first + candidates[index2] + candidates[index3];
sums.push_back(sum);
}
}
// find all quadruples, same idea as checkTriple, but this time 1+3 number must match
void checkQuadruple(unsigned int first, const std::vector<unsigned int>& candidates)
{
for (size_t index2 = 0; index2 < candidates.size(); index2++)
for (size_t index3 = index2 + 1; index3 < candidates.size(); index3++)
{
// not even a triple ?
if (!match(candidates[index2], candidates[index3]))
continue;
// match fourth number
for (size_t index4 = index3 + 1; index4 < candidates.size(); index4++)
if (match(candidates[index2], candidates[index4]) &&
match(candidates[index3], candidates[index4]))
{
// append sum to result set
auto sum = first + candidates[index2] + candidates[index3] + candidates[index4];
sums.push_back(sum);
}
}
}
// find all quintuples, same idea as above, just nested one level deeper
void checkQuintuple(unsigned int first, const std::vector<unsigned int>& candidates)
{
for (size_t index2 = 0; index2 < candidates.size(); index2++)
for (size_t index3 = index2 + 1; index3 < candidates.size(); index3++)
{
// not even a triple ?
if (!match(candidates[index2], candidates[index3]))
continue;
for (size_t index4 = index3 + 1; index4 < candidates.size(); index4++)
{
// not even a quadruple ?
if (!match(candidates[index2], candidates[index4]) ||
!match(candidates[index3], candidates[index4]))
continue;
// match fifth number
for (size_t index5 = index4 + 1; index5 < candidates.size(); index5++)
if (match(candidates[index2], candidates[index5]) &&
match(candidates[index3], candidates[index5]) &&
match(candidates[index4], candidates[index5]))
{
// append sum to result set
auto sum = first + candidates[index2] + candidates[index3] +
candidates[index4] + candidates[index5];
sums.push_back(sum);
}
}
}
}
int main()
{
// all primes are below this threshold
unsigned int maxPrime = 20000;
// number of primes in a group
unsigned int size = 5;
std::cin >> maxPrime >> size;
// all primes that can be part of a result set
std::vector<unsigned int> primes;
// find all primes up to n (20000 at most)
// note: 2 is deliberately excluded because "any combination must be a prime"
// => but any number where we concat 2 to the end can't be prime
for (unsigned int i = 3; i < maxPrime; i += 2)
{
bool isPrime = true;
for (auto p : primes)
{
if (p*p > i)
break;
if (i % p == 0)
{
isPrime = false;
break;
}
}
if (isPrime)
primes.push_back(i);
}
for (size_t i = 0; i < primes.size(); i++)
{
auto smallPrime = primes[i];
// no prime number ends with 5 (except 5 itself) => just a simple performance tweak
if (smallPrime == 5)
continue;
// find all larger primes that can be paired with "smallPrime"
std::vector<unsigned int> candidates;
for (size_t j = i + 1; j < primes.size(); j++)
{
auto largePrime = primes[j];
if (match(smallPrime, largePrime))
candidates.push_back(largePrime);
}
// all other candidates must be "pairable" to each other, too
if (size == 3)
checkTriple(smallPrime, candidates);
else if (size == 4)
checkQuadruple(smallPrime, candidates);
else // size == 5
checkQuintuple(smallPrime, candidates);
}
// print all sums in ascending order, some sums may occur multiple times
std::sort(sums.begin(), sums.end());
for (auto s : sums)
std::cout << s << std::endl;
}
This solution contains 38 empty lines, 65 comments and 5 preprocessor commands.
Benchmark
The correct solution to the original Project Euler problem was found in 1.7 seconds on an Intel® Core™ i7-2600K CPU @ 3.40GHz.
(compiled for x86_64 / Linux, GCC flags: -O3 -march=native -fno-exceptions -fno-rtti -std=gnu++11 -DORIGINAL
)
See here for a comparison of all solutions.
Note: interactive tests run on a weaker (=slower) computer. Some interactive tests are compiled without -DORIGINAL
.
Changelog
March 1, 2017 submitted solution
April 25, 2017 added comments
Hackerrank
see https://www.hackerrank.com/contests/projecteuler/challenges/euler060
My code solves 15 out of 15 test cases (score: 100%)
Difficulty
Project Euler ranks this problem at 20% (out of 100%).
Hackerrank describes this problem as hard.
Note:
Hackerrank has strict execution time limits (typically 2 seconds for C++ code) and often a much wider input range than the original problem.
In my opinion, Hackerrank's modified problems are usually a lot harder to solve. As a rule thumb: brute-force is rarely an option.
Similar problems at Project Euler
Problem 50: Consecutive prime sum
Problem 58: Spiral primes
Note: I'm not even close to solving all problems at Project Euler. Chances are that similar problems do exist and I just haven't looked at them.
Links
projecteuler.net/thread=60 - the best forum on the subject (note: you have to submit the correct solution first)
Code in various languages:
C# www.mathblog.dk/project-euler-60-primes-concatenate/ (written by Kristian Edlund)
Python github.com/hughdbrown/Project-Euler/blob/master/euler-060.py (written by Hugh Brown)
Python github.com/nayuki/Project-Euler-solutions/blob/master/python/p060.py (written by Nayuki)
Python github.com/steve98654/ProjectEuler/blob/master/060.py
C++ github.com/Meng-Gen/ProjectEuler/blob/master/60.cc (written by Meng-Gen Tsai)
C++ github.com/roosephu/project-euler/blob/master/60.cpp (written by Yuping Luo)
Java github.com/nayuki/Project-Euler-solutions/blob/master/java/p060.java (written by Nayuki)
Java github.com/thrap/project-euler/blob/master/src/Java/Problem60.java (written by Magnus Solheim Thrap)
Go github.com/frrad/project-euler/blob/master/golang/Problem060.go (written by Frederick Robinson)
Mathematica github.com/steve98654/ProjectEuler/blob/master/060.nb
Haskell github.com/nayuki/Project-Euler-solutions/blob/master/haskell/p060.hs (written by Nayuki)
Clojure github.com/rm-hull/project-euler/blob/master/src/euler060.clj (written by Richard Hull)
Scala github.com/samskivert/euler-scala/blob/master/Euler060.scala (written by Michael Bayne)
Perl github.com/gustafe/projecteuler/blob/master/060-Prime-pair-sets.pl (written by Gustaf Erikson)
Rust github.com/gifnksm/ProjectEulerRust/blob/master/src/bin/p060.rs
Those links are just an unordered selection of source code I found with a semi-automatic search script on Google/Bing/GitHub/whatever.
You will probably stumble upon better solutions when searching on your own.
Maybe not all linked resources produce the correct result and/or exceed time/memory limits.
Heatmap
Please click on a problem's number to open my solution to that problem:
green | solutions solve the original Project Euler problem and have a perfect score of 100% at Hackerrank, too | |
yellow | solutions score less than 100% at Hackerrank (but still solve the original problem easily) | |
gray | problems are already solved but I haven't published my solution yet | |
blue | solutions are relevant for Project Euler only: there wasn't a Hackerrank version of it (at the time I solved it) or it differed too much | |
orange | problems are solved but exceed the time limit of one minute or the memory limit of 256 MByte | |
red | problems are not solved yet but I wrote a simulation to approximate the result or verified at least the given example - usually I sketched a few ideas, too | |
black | problems are solved but access to the solution is blocked for a few days until the next problem is published | |
[new] | the flashing problem is the one I solved most recently |
I stopped working on Project Euler problems around the time they released 617.
1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9 | 10 | 11 | 12 | 13 | 14 | 15 | 16 | 17 | 18 | 19 | 20 | 21 | 22 | 23 | 24 | 25 |
26 | 27 | 28 | 29 | 30 | 31 | 32 | 33 | 34 | 35 | 36 | 37 | 38 | 39 | 40 | 41 | 42 | 43 | 44 | 45 | 46 | 47 | 48 | 49 | 50 |
51 | 52 | 53 | 54 | 55 | 56 | 57 | 58 | 59 | 60 | 61 | 62 | 63 | 64 | 65 | 66 | 67 | 68 | 69 | 70 | 71 | 72 | 73 | 74 | 75 |
76 | 77 | 78 | 79 | 80 | 81 | 82 | 83 | 84 | 85 | 86 | 87 | 88 | 89 | 90 | 91 | 92 | 93 | 94 | 95 | 96 | 97 | 98 | 99 | 100 |
101 | 102 | 103 | 104 | 105 | 106 | 107 | 108 | 109 | 110 | 111 | 112 | 113 | 114 | 115 | 116 | 117 | 118 | 119 | 120 | 121 | 122 | 123 | 124 | 125 |
126 | 127 | 128 | 129 | 130 | 131 | 132 | 133 | 134 | 135 | 136 | 137 | 138 | 139 | 140 | 141 | 142 | 143 | 144 | 145 | 146 | 147 | 148 | 149 | 150 |
151 | 152 | 153 | 154 | 155 | 156 | 157 | 158 | 159 | 160 | 161 | 162 | 163 | 164 | 165 | 166 | 167 | 168 | 169 | 170 | 171 | 172 | 173 | 174 | 175 |
176 | 177 | 178 | 179 | 180 | 181 | 182 | 183 | 184 | 185 | 186 | 187 | 188 | 189 | 190 | 191 | 192 | 193 | 194 | 195 | 196 | 197 | 198 | 199 | 200 |
201 | 202 | 203 | 204 | 205 | 206 | 207 | 208 | 209 | 210 | 211 | 212 | 213 | 214 | 215 | 216 | 217 | 218 | 219 | 220 | 221 | 222 | 223 | 224 | 225 |
226 | 227 | 228 | 229 | 230 | 231 | 232 | 233 | 234 | 235 | 236 | 237 | 238 | 239 | 240 | 241 | 242 | 243 | 244 | 245 | 246 | 247 | 248 | 249 | 250 |
251 | 252 | 253 | 254 | 255 | 256 | 257 | 258 | 259 | 260 | 261 | 262 | 263 | 264 | 265 | 266 | 267 | 268 | 269 | 270 | 271 | 272 | 273 | 274 | 275 |
276 | 277 | 278 | 279 | 280 | 281 | 282 | 283 | 284 | 285 | 286 | 287 | 288 | 289 | 290 | 291 | 292 | 293 | 294 | 295 | 296 | 297 | 298 | 299 | 300 |
301 | 302 | 303 | 304 | 305 | 306 | 307 | 308 | 309 | 310 | 311 | 312 | 313 | 314 | 315 | 316 | 317 | 318 | 319 | 320 | 321 | 322 | 323 | 324 | 325 |
326 | 327 | 328 | 329 | 330 | 331 | 332 | 333 | 334 | 335 | 336 | 337 | 338 | 339 | 340 | 341 | 342 | 343 | 344 | 345 | 346 | 347 | 348 | 349 | 350 |
351 | 352 | 353 | 354 | 355 | 356 | 357 | 358 | 359 | 360 | 361 | 362 | 363 | 364 | 365 | 366 | 367 | 368 | 369 | 370 | 371 | 372 | 373 | 374 | 375 |
376 | 377 | 378 | 379 | 380 | 381 | 382 | 383 | 384 | 385 | 386 | 387 | 388 | 389 | 390 | 391 | 392 | 393 | 394 | 395 | 396 | 397 | 398 | 399 | 400 |
401 | 402 | 403 | 404 | 405 | 406 | 407 | 408 | 409 | 410 | 411 | 412 | 413 | 414 | 415 | 416 | 417 | 418 | 419 | 420 | 421 | 422 | 423 | 424 | 425 |
426 | 427 | 428 | 429 | 430 | 431 | 432 | 433 | 434 | 435 | 436 | 437 | 438 | 439 | 440 | 441 | 442 | 443 | 444 | 445 | 446 | 447 | 448 | 449 | 450 |
451 | 452 | 453 | 454 | 455 | 456 | 457 | 458 | 459 | 460 | 461 | 462 | 463 | 464 | 465 | 466 | 467 | 468 | 469 | 470 | 471 | 472 | 473 | 474 | 475 |
476 | 477 | 478 | 479 | 480 | 481 | 482 | 483 | 484 | 485 | 486 | 487 | 488 | 489 | 490 | 491 | 492 | 493 | 494 | 495 | 496 | 497 | 498 | 499 | 500 |
501 | 502 | 503 | 504 | 505 | 506 | 507 | 508 | 509 | 510 | 511 | 512 | 513 | 514 | 515 | 516 | 517 | 518 | 519 | 520 | 521 | 522 | 523 | 524 | 525 |
526 | 527 | 528 | 529 | 530 | 531 | 532 | 533 | 534 | 535 | 536 | 537 | 538 | 539 | 540 | 541 | 542 | 543 | 544 | 545 | 546 | 547 | 548 | 549 | 550 |
551 | 552 | 553 | 554 | 555 | 556 | 557 | 558 | 559 | 560 | 561 | 562 | 563 | 564 | 565 | 566 | 567 | 568 | 569 | 570 | 571 | 572 | 573 | 574 | 575 |
576 | 577 | 578 | 579 | 580 | 581 | 582 | 583 | 584 | 585 | 586 | 587 | 588 | 589 | 590 | 591 | 592 | 593 | 594 | 595 | 596 | 597 | 598 | 599 | 600 |
601 | 602 | 603 | 604 | 605 | 606 | 607 | 608 | 609 | 610 | 611 | 612 | 613 | 614 | 615 | 616 | 617 | 618 | 619 | 620 | 621 | 622 | 623 | 624 | 625 |
626 | 627 | 628 | 629 | 630 | 631 | 632 | 633 | 634 | 635 | 636 | 637 | 638 | 639 | 640 | 641 | 642 | 643 | 644 | 645 | 646 | 647 | 648 | 649 | 650 |
651 | 652 | 653 | 654 | 655 | 656 | 657 | 658 | 659 | 660 | 661 | 662 | 663 | 664 | 665 | 666 | 667 | 668 | 669 | 670 | 671 | 672 | 673 | 674 | 675 |
676 | 677 | 678 | 679 | 680 | 681 | 682 | 683 | 684 | 685 | 686 | 687 | 688 | 689 | 690 | 691 | 692 | 693 | 694 | 695 | 696 | 697 | 698 | 699 | 700 |
701 | 702 | 703 | 704 | 705 | 706 | 707 | 708 | 709 | 710 | 711 | 712 | 713 | 714 | 715 | 716 | 717 | 718 | 719 | 720 | 721 | 722 | 723 | 724 | 725 |
726 | 727 | 728 | 729 | 730 | 731 | 732 | 733 | 734 | 735 | 736 | 737 | 738 | 739 | 740 | 741 | 742 | 743 | 744 | 745 | 746 | 747 | 748 | 749 | 750 |
751 | 752 | 753 | 754 | 755 | 756 | 757 | 758 | 759 | 760 | 761 | 762 | 763 | 764 | 765 | 766 | 767 | 768 | 769 | 770 | 771 | 772 | 773 | 774 | 775 |
776 | 777 | 778 | 779 | 780 | 781 | 782 | 783 | 784 | 785 | 786 | 787 | 788 | 789 | 790 | 791 | 792 | 793 | 794 | 795 | 796 | 797 | 798 | 799 | 800 |
801 | 802 | 803 | 804 | 805 | 806 | 807 | 808 | 809 | 810 | 811 | 812 | 813 | 814 |
I scored 13526 points (out of 15700 possible points, top rank was 17 out of ≈60000 in August 2017) at Hackerrank's Project Euler+.
My username at Project Euler is stephanbrumme while it's stbrumme at Hackerrank.
Look at my progress and performance pages to get more details.
Copyright
I hope you enjoy my code and learn something - or give me feedback how I can improve my solutions.
All of my solutions can be used for any purpose and I am in no way liable for any damages caused.
You can even remove my name and claim it's yours. But then you shall burn in hell.
The problems and most of the problems' images were created by Project Euler.
Thanks for all their endless effort !!!
<< problem 59 - XOR decryption | Cyclical figurate numbers - problem 61 >> |